/*
 * @(#)EJPDFDemo.java	Version 1.0  <April 02, 2003>
 *
 * Copyright 2000-2002 Elegant MicroWeb Technologies Pvt. Ltd. (EMTPL). All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * - Redistributions of source code is not permitted under any conditions.
 * 
 * - Redistribution in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of Elegant MicroWeb Technologies Pvt. Ltd. or the names of contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES,
 * INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. EMTPL AND
 * ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES OR LIABILITIES
 * SUFFERED BY LICENSEE AS A RESULT OF  OR RELATING TO USE, MODIFICATION
 * OR DISTRIBUTION OF THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL
 * EMTPL OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE
 * DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,
 * ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF EMTPL HAS
 * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * 
 * You acknowledge that Software is not designed, licensed or intended
 * for use in the design, construction, operation or maintenance of any
 * nuclear facility or any other illegal activity.
 */

import com.elegantj.pdf.*;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

//EJPDFDemo demonstrates the ElegantJ PDF Library
public class EJPDFDemo
{
	// The color which is used to fill the text
	public static Color HEADER_TEXT_FILL_COLOR = new Color(0, 0, 200);

	// The pdf object for the
	private PDF pdf;
	// The mediabox object used to set the dimension of the page
	private MediaBox mediaBox = MediaBox.MEDIA_a4;
	// The true type font
	private TrueTypeFont trueTypeFont;
	// The type1 font
	private Type1Font labelFont;
	// The type1 font
	private Type1Font type1Font;
	// The true type cjk font
	private TrueTypeCJKFont trueTypeCJKFont;
	// The PDFImage
	private PDFImage pdfImage;

	// The index page
	private Page pdfIndexPage;
	// The text attributes page 1
	private Page pdfTextAttributesPage1;
	// The text attributes page 2
	private Page pdfTextAttributesPage2;
	// The PDF font page
	private Page pdfFontPage;
	// The PDF line page
	private Page pdfLinePage;
	// The PDF rectangle page
	private Page pdfRectanglePage;
	// The PDF circle page
	private Page pdfCirclePage;
	// The PDF oval page
	private Page pdfOvalPage;
	// The PDF arc page
	private Page pdfArcPage;
	// The PDF polygon page
	private Page pdfPolygonPage;
	// The PDF pattern page1
	private Page pdfPatternPage1;
	// The PDF pattern page2
	private Page pdfPatternPage2;
	// The PDF Annotatoin page1
	private Page pdfAnnotationPage1;
	// The PDF Annotatoin page2
	private Page pdfAnnotationPage2;
	// The PDF Image page
	private Page pdfImagePage;
	// The PDF Table page1
	private Page pdfTablePage1;
	// The PDF Table page2
	private Page pdfTablePage2;
	// The PDF Table page3
	private Page pdfTablePage3;

	//Constructs the EJPDFDemo
	public EJPDFDemo()
	{
		try
		{
			// Create an object of PDF with 'USEOUTLINES' argument, which cause the
			// outlines to be displayed when the PDF file first opens in the viewer
			pdf = new PDF(Catalog.USEOUTLINES);


			// Create an object of the Type1Font with the built in HELVETICA font,
			// and the winansi encoding
			labelFont = new Type1Font(Type1Font.HELVETICA, Type1Font.WINANSI);
			// Create an object of the Type1Font with the HELVETICA font,
			// and the winansi encoding
			type1Font = new Type1Font("./resources/Cartwrig.afm", "./resources/Cartwrig.pfb", Type1Font.WINANSI);

			// Create an object of the TrueTypeFont with the embedded = true and subset = true
			trueTypeFont = new TrueTypeFont("./resources/arial.ttf", Type1Font.REGULAR, Type1Font.WINANSI, true, true);

			// Create an object of the TrueTypeCJKFont with the encoding = IDENTITY_H
			trueTypeCJKFont = new TrueTypeCJKFont("./resources/hgrgep.ttf", TrueTypeCJKFont.REGULAR, TrueTypeCJKFont.IDENTITY_H);

			// Create an object of the PDFImage
			pdfImage = new PDFImage(getClass().getResource("./resources/image2.jpg"));

//			pdfIndexPage = createPDFIndexPage();
			// adds the page to the pdf
//			pdf.add(pdfIndexPage);

//			pdfTextAttributesPage1 = createPDFTextAttributesPage1();
			// adds the page to the pdf
//			pdf.add(pdfTextAttributesPage1);

//			pdfTextAttributesPage2 = createPDFTextAttributesPage2();
			// adds the page to the pdf
//			pdf.add(pdfTextAttributesPage2);

//			pdfFontPage = createPDFFontPage();
			// adds the page to the pdf
//			pdf.add(pdfFontPage);

//			pdfLinePage = createPDFLinePage();
			// adds the page to the pdf
//			pdf.add(pdfLinePage);

//			pdfRectanglePage = createPDFRectanglePage();
			// adds the page to the pdf
//			pdf.add(pdfRectanglePage);

//			pdfCirclePage = createPDFCirclePage();
			// adds the page to the pdf
//			pdf.add(pdfCirclePage);

//			pdfOvalPage = createPDFOvalPage();
			// adds the page to the pdf
//			pdf.add(pdfOvalPage);

//			pdfArcPage = createPDFArcPage();
			// adds the page to the pdf
//			pdf.add(pdfArcPage);

//			pdfPolygonPage = createPDFPolygonPage();
			// adds the page to the pdf
//			pdf.add(pdfPolygonPage);

//			pdfPatternPage1 = createPDFPatternPage1();
			// adds the page to the pdf
//			pdf.add(pdfPatternPage1);

//			pdfPatternPage2 = createPDFPatternPage2();
			// adds the page to the pdf
//			pdf.add(pdfPatternPage2);

//			pdfAnnotationPage1 = createPDFAnnotationPage1();
			// adds the page to the pdf
//			pdf.add(pdfAnnotationPage1);

//			pdfAnnotationPage2 = createPDFAnnotationPage2();
			// adds the page to the pdf
//			pdf.add(pdfAnnotationPage2);

			pdfImagePage = createPDFImagePage();
			// adds the page to the pdf
			pdf.add(pdfImagePage);

//			pdfTablePage1 = createPDFTablePage1();
			// adds the page to the pdf
//			pdf.add(pdfTablePage1);

//			pdfTablePage2 = createPDFTablePage2();
			// adds the page to the pdf
//			pdf.add(pdfTablePage2);

//			pdfTablePage3 = createPDFTablePage3();
			// adds the page to the pdf
//			pdf.add(pdfTablePage3);

//			assignValuesToPDFIndexPage(pdfIndexPage);

			// creates the outline tree for the PDF
//			createOutlinesTree();

			// creates the OutputStream where this PDF will be write
			OutputStream os = new FileOutputStream("EJPDFDemo.pdf");
			// write the EJPDFDemo pdf to the EJPDFDemo.pdf file
			pdf.write(os);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	// creates the index page
	private Page createPDFIndexPage() throws IOException
	{
		// creates the PDF page
		Page page = new Page(pdf.getPages(), mediaBox);
		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText	labelPDFText = new PDFText("ElegantJ PDF Demo Index", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		// sets the PDFFont to the PDFText
		labelPDFText.setPDFFont(labelFont);
		// sets the font size to the PDFText
		labelPDFText.setFontSize(25);
		// sets the fill color ot the PDFText
		labelPDFText.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true
		labelPDFText.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(labelPDFText);
		return page;
	}

	// assigns the value to the Index page
	private void assignValuesToPDFIndexPage(Page page) throws IOException
	{
		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText pdfText1 = new PDFText("01.   Go to PDFText Attributes Demo 1", mediaBox.x + 50, 100, mediaBox.width - 100, 100 + 25);
		pdfText1.setPDFFont(labelFont);
		// sets the font size for the PDFText
		pdfText1.setFontSize(15);
		// creates the PDFLinkAnnotation with destination page, and x, y, width, height for the annotation
		PDFLinkAnnotation pdfText1Annot = new PDFLinkAnnotation(pdfTextAttributesPage1, mediaBox.x + 50, 100, pdfText1.getStringWidth(pdfText1.getText()), 16, 0, 0);
		// adds the text to the page
		page.addText(pdfText1);
		// adds the annotation to the page
		page.addAnnotation(pdfText1Annot);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText pdfText2 = new PDFText("02.   Go to PDFText Attributes Demo 2", mediaBox.x + 50, 125, mediaBox.width - 100, 125 + 25);
		pdfText2.setPDFFont(labelFont);
		// sets the font size for the PDFText
		pdfText2.setFontSize(15);
		// creates the PDFLinkAnnotation with destination page, and x, y, width, height for the annotation
		PDFLinkAnnotation pdfText2Annot = new PDFLinkAnnotation(pdfTextAttributesPage2, mediaBox.x + 50, 125, pdfText2.getStringWidth(pdfText2.getText()), 16, 0, 0);
		// adds the text to the page
		page.addText(pdfText2);
		// adds the annotation to the page
		page.addAnnotation(pdfText2Annot);

		PDFText pdfFont = new PDFText("03.   Go to PDFFont Demo", mediaBox.x + 50, 150, mediaBox.width - 100, 150 + 25);
		pdfFont.setPDFFont(labelFont);
		pdfFont.setFontSize(15);
		PDFLinkAnnotation pdfFontAnnot = new PDFLinkAnnotation(pdfFontPage, mediaBox.x + 50, 150, pdfFont.getStringWidth(pdfFont.getText()), 16, 0, 0);
		page.addText(pdfFont);
		page.addAnnotation(pdfFontAnnot);

		PDFText pdfLine = new PDFText("04.   Go to PDFLine Demo", mediaBox.x + 50, 175, mediaBox.width - 100, 175 + 25);
		pdfLine.setPDFFont(labelFont);
		pdfLine.setFontSize(15);
		PDFLinkAnnotation pdfLineAnnot = new PDFLinkAnnotation(pdfLinePage, mediaBox.x + 50, 175, pdfLine.getStringWidth(pdfLine.getText()), 16, 0, 0);
		page.addText(pdfLine);
		page.addAnnotation(pdfLineAnnot);

		PDFText pdfRect = new PDFText("05.   Go to PDFRectangle Demo", mediaBox.x + 50, 200, mediaBox.width - 100, 200 + 25);
		pdfRect.setPDFFont(labelFont);
		pdfRect.setFontSize(15);
		PDFLinkAnnotation pdfRectAnnot = new PDFLinkAnnotation(pdfRectanglePage, mediaBox.x + 50, 200, pdfRect.getStringWidth(pdfRect.getText()), 16, 0, 0);
		page.addText(pdfRect);
		page.addAnnotation(pdfRectAnnot);

		PDFText pdfCircle = new PDFText("06.   Go to PDFCircle Demo", mediaBox.x + 50, 225, mediaBox.width - 100, 225 + 25);
		pdfCircle.setPDFFont(labelFont);
		pdfCircle.setFontSize(15);
		PDFLinkAnnotation pdfCircleAnnot = new PDFLinkAnnotation(pdfCirclePage, mediaBox.x + 50, 225, pdfCircle.getStringWidth(pdfCircle.getText()), 16, 0, 0);
		page.addText(pdfCircle);
		page.addAnnotation(pdfCircleAnnot);

		PDFText pdfOval = new PDFText("07.   Go to PDFOval Demo", mediaBox.x + 50, 250, mediaBox.width - 100, 250 + 25);
		pdfOval.setPDFFont(labelFont);
		pdfOval.setFontSize(15);
		PDFLinkAnnotation pdfOvalAnnot = new PDFLinkAnnotation(pdfOvalPage, mediaBox.x + 50, 250, pdfOval.getStringWidth(pdfOval.getText()), 16, 0, 0);
		page.addText(pdfOval);
		page.addAnnotation(pdfOvalAnnot);

		PDFText pdfArc = new PDFText("08.   Go to PDFArc Demo", mediaBox.x + 50, 275, mediaBox.width - 100, 275 + 25);
		pdfArc.setPDFFont(labelFont);
		pdfArc.setFontSize(15);
		PDFLinkAnnotation pdfArcAnnot = new PDFLinkAnnotation(pdfArcPage, mediaBox.x + 50, 275, pdfArc.getStringWidth(pdfArc.getText()), 16, 0, 0);
		page.addText(pdfArc);
		page.addAnnotation(pdfArcAnnot);

		PDFText pdfPolygon = new PDFText("09.   Go to PDFPolygon Demo", mediaBox.x + 50, 300, mediaBox.width - 100, 300 + 25);
		pdfPolygon.setPDFFont(labelFont);
		pdfPolygon.setFontSize(15);
		PDFLinkAnnotation pdfPolygonAnnot = new PDFLinkAnnotation(pdfPolygonPage, mediaBox.x + 50, 300, pdfPolygon.getStringWidth(pdfPolygon.getText()), 16, 0, 0);
		page.addText(pdfPolygon);
		page.addAnnotation(pdfPolygonAnnot);

		PDFText pdfPattern1 = new PDFText("10.   Go to PDFPattern Demo 1", mediaBox.x + 50, 325, mediaBox.width - 100, 325 + 25);
		pdfPattern1.setPDFFont(labelFont);
		pdfPattern1.setFontSize(15);
		PDFLinkAnnotation pdfPattern1Annot = new PDFLinkAnnotation(pdfPatternPage1, mediaBox.x + 50, 325, pdfPattern1.getStringWidth(pdfPattern1.getText()), 16, 0, 0);
		page.addText(pdfPattern1);
		page.addAnnotation(pdfPattern1Annot);

		PDFText pdfPattern2 = new PDFText("11.   Go to PDFPattern Demo 2", mediaBox.x + 50, 350, mediaBox.width - 100, 350 + 25);
		pdfPattern2.setPDFFont(labelFont);
		pdfPattern2.setFontSize(15);
		PDFLinkAnnotation pdfPattern2Annot = new PDFLinkAnnotation(pdfPatternPage2, mediaBox.x + 50, 350, pdfPattern2.getStringWidth(pdfPattern2.getText()), 16, 0, 0);
		page.addText(pdfPattern2);
		page.addAnnotation(pdfPattern2Annot);

		PDFText pdfAnnot1 = new PDFText("12.   Go to PDFRubberStamp Annotation Demo", mediaBox.x + 50, 375, mediaBox.width - 100, 375 + 25);
		pdfAnnot1.setPDFFont(labelFont);
		pdfAnnot1.setFontSize(15);
		PDFLinkAnnotation pdfAnnot1Annot = new PDFLinkAnnotation(pdfAnnotationPage1, mediaBox.x + 50, 375, pdfAnnot1.getStringWidth(pdfAnnot1.getText()), 16, 0, 0);
		page.addText(pdfAnnot1);
		page.addAnnotation(pdfAnnot1Annot);

		PDFText pdfAnnot2 = new PDFText("13.   Go to PDFText and Link Annotation Demo", mediaBox.x + 50, 400, mediaBox.width - 100, 400 + 25);
		pdfAnnot2.setPDFFont(labelFont);
		pdfAnnot2.setFontSize(15);
		PDFLinkAnnotation pdfAnnot2Annot = new PDFLinkAnnotation(pdfAnnotationPage2, mediaBox.x + 50, 400, pdfAnnot2.getStringWidth(pdfAnnot2.getText()), 16, 0, 0);
		page.addText(pdfAnnot2);
		page.addAnnotation(pdfAnnot2Annot);

		PDFText pdfImage = new PDFText("14.   Go to PDFImage Demo", mediaBox.x + 50, 425, mediaBox.width - 100, 425 + 25);
		pdfImage.setPDFFont(labelFont);
		pdfImage.setFontSize(15);
		PDFLinkAnnotation pdfImageAnnot = new PDFLinkAnnotation(pdfImagePage, mediaBox.x + 50, 425, pdfImage.getStringWidth(pdfImage.getText()), 16, 0, 0);
		page.addText(pdfImage);
		page.addAnnotation(pdfImageAnnot);

		PDFText pdfTable1 = new PDFText("15.   Go to PDFTable Demo 1", mediaBox.x + 50, 450, mediaBox.width - 100, 450 + 25);
		pdfTable1.setPDFFont(labelFont);
		pdfTable1.setFontSize(15);
		PDFLinkAnnotation pdfTable1Annot = new PDFLinkAnnotation(pdfTablePage1, mediaBox.x + 50, 450, pdfTable1.getStringWidth(pdfTable1.getText()), 16, 0, 0);
		page.addText(pdfTable1);
		page.addAnnotation(pdfTable1Annot);

		PDFText pdfTable2 = new PDFText("16.   Go to PDFTable Demo 2", mediaBox.x + 50, 475, mediaBox.width - 100, 475 + 25);
		pdfTable2.setPDFFont(labelFont);
		pdfTable2.setFontSize(15);
		PDFLinkAnnotation pdfTable2Annot = new PDFLinkAnnotation(pdfTablePage2, mediaBox.x + 50, 475, pdfTable2.getStringWidth(pdfTable2.getText()), 16, 0, 0);
		page.addText(pdfTable2);
		page.addAnnotation(pdfTable2Annot);

		PDFText pdfTable3 = new PDFText("17.   Go to PDFTable Demo 3", mediaBox.x + 50, 500, mediaBox.width - 100, 500 + 25);
		pdfTable3.setPDFFont(labelFont);
		pdfTable3.setFontSize(15);
		PDFLinkAnnotation pdfTable3Annot = new PDFLinkAnnotation(pdfTablePage3, mediaBox.x + 50, 500, pdfTable3.getStringWidth(pdfTable3.getText()), 16, 0, 0);
		page.addText(pdfTable3);
		page.addAnnotation(pdfTable3Annot);
	}

	// creates the pdf text attributes page 1
	private Page createPDFTextAttributesPage1() throws IOException
	{
		String text = "" +
		"PDF is a file format used to represent a document in a manner independent of the " +
		"application software, hardware, and operating system used to create it. A PDF file " +
		"contains a PDF document and other supporting data." +
		"A PDF document contains one or more pages. Each page in the document may " +
		"contain any combination of text, graphics, and images in a device- and resolution-independent " +
		"format. This is the page description. A PDF document may also" +
		"contain information possible only in an electronic representation, such as hypertext " +
		"links, sound, and movies." +
		"In addition to a document, a PDF file contains the version of the PDF specification " +
		"used in the file and information about the location of important structures in the " +
		"file." +
		"To understand PDF, it is important to understand how PDF documents will be " +
		"produced and used. As PDF documents and applications that read PDF files " +
		"become more prevalent, new ways of creating and using PDF files will be " +
		"invented. This is one of the goals of this book to make the file format accessible " +
		"so that application developers can expand on the ideas behind PDF and the " +
		"applications that initially support it.";

		// creates the pdf page
		Page page = new Page(pdf.getPages(), mediaBox);
		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText	labelPDFText = new PDFText("ElegantJ PDF Text Demo with Text Attributes-1", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		// sets the PDFFont to the text
		labelPDFText.setPDFFont(labelFont);
		// sets the Font size to the text
		labelPDFText.setFontSize(18);
		// sets the fill color for the text
		labelPDFText.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the alignment to the text
		labelPDFText.setAlignment(PDFText.CENTER);
		// sets the underline to the text
		labelPDFText.setUnderLine(true);
		// adds the text to the page
		page.addText(labelPDFText);

		PDFText leftAlignedTextLabel = new PDFText("Left Aligned Text", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		// sets the left alignment for the text
		leftAlignedTextLabel.setAlignment(PDFText.CENTER);
		leftAlignedTextLabel.setPDFFont(labelFont);
		leftAlignedTextLabel.setFontSize(14);
		leftAlignedTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		leftAlignedTextLabel.setUnderLine(true);
		page.addText(leftAlignedTextLabel);

		PDFText leftAlignedText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 115, mediaBox.width - 50, mediaBox.y + 115 + 170);
		leftAlignedText.setAlignment(PDFText.LEFT);
		leftAlignedText.setPDFFont(labelFont);
		leftAlignedText.setFontSize(10);
		page.addText(leftAlignedText);

		PDFText centerAlignedTextLabel = new PDFText("Center Aligned Text", mediaBox.x + 50, mediaBox.y + 260, mediaBox.width - 50, mediaBox.y + 285 + 25);
		// sets the center alignment for the text
		centerAlignedTextLabel.setAlignment(PDFText.CENTER);
		centerAlignedTextLabel.setPDFFont(labelFont);
		centerAlignedTextLabel.setFontSize(14);
		centerAlignedTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		centerAlignedTextLabel.setUnderLine(true);
		page.addText(centerAlignedTextLabel);

		PDFText centerAlignedText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 285, mediaBox.width - 50, mediaBox.y + 310 + 170);
		centerAlignedText.setAlignment(PDFText.CENTER);
		centerAlignedText.setPDFFont(labelFont);
		centerAlignedText.setFontSize(10);
		page.addText(centerAlignedText);

		PDFText rightAlignedTextLabel = new PDFText("Right Aligned Text", mediaBox.x + 50, mediaBox.y + 430, mediaBox.width - 50, mediaBox.y + 480 + 25);
		rightAlignedTextLabel.setAlignment(PDFText.CENTER);
		rightAlignedTextLabel.setPDFFont(labelFont);
		rightAlignedTextLabel.setFontSize(14);
		rightAlignedTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		rightAlignedTextLabel.setUnderLine(true);
		page.addText(rightAlignedTextLabel);

		PDFText rightAlignedText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 455, mediaBox.width - 50, mediaBox.y + 505 + 170);
		// sets the right alignment for the text
		rightAlignedText.setAlignment(PDFText.RIGHT);
		rightAlignedText.setPDFFont(labelFont);
		rightAlignedText.setFontSize(10);
		page.addText(rightAlignedText);

		PDFText justifyAlignedTextLabel = new PDFText("Justify Aligned Text", mediaBox.x + 50, mediaBox.y + 600, mediaBox.width - 50, mediaBox.y + 675 + 25);
		justifyAlignedTextLabel.setAlignment(PDFText.CENTER);
		justifyAlignedTextLabel.setPDFFont(labelFont);
		justifyAlignedTextLabel.setFontSize(14);
		justifyAlignedTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		justifyAlignedTextLabel.setUnderLine(true);
		page.addText(justifyAlignedTextLabel);

		PDFText justifyAlignedText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 625 , mediaBox.width - 50, mediaBox.y + 700 + 170);
		// sets the justify alignment for the text
		justifyAlignedText.setAlignment(PDFText.JUSTIFY);
		justifyAlignedText.setPDFFont(labelFont);
		justifyAlignedText.setFontSize(10);
		page.addText(justifyAlignedText);
		return page;
	}

	// creates the text attributes page2
	private Page createPDFTextAttributesPage2() throws IOException
	{
		String text = "" +
		"PDF is a file format used to represent a document in a manner independent of the " +
		"application software, hardware, and operating system used to create it. A PDF file " +
		"contains a PDF document and other supporting data. A PDF document contains one or more pages.";
		String text2 = "" +
		"PDF is a file format used to represent a document in a manner independent of the " +
		"application software, hardware, and operating system used to create it.";

		// creates the page
		Page page = new Page(pdf.getPages(), mediaBox);
		// creates the PDFText
		PDFText	labelPDFText = new PDFText("ElegantJ PDF Text Demo with Text Attributes-2", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		// sets the PDFFont to the text
		labelPDFText.setPDFFont(labelFont);
		// sets the Font size to the text
		labelPDFText.setFontSize(18);
		// sets the fill color
		labelPDFText.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the alignment for the text
		labelPDFText.setAlignment(PDFText.CENTER);
		// sets the underline true for the text
		labelPDFText.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(labelPDFText);

		// creates the PDFText
		PDFText underLineTextLabel = new PDFText("Text with Underline", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		// sets the alignment for the text
		underLineTextLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		underLineTextLabel.setPDFFont(labelFont);
		// sets the font size for the text
		underLineTextLabel.setFontSize(14);
		// sets the fill color for the text
		underLineTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the under line true
		underLineTextLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(underLineTextLabel);

		// creates the PDFText
		PDFText underLineText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 115, mediaBox.width - 50, mediaBox.y + 115 + 50);
		// sets the alignment for the text
		underLineText.setAlignment(PDFText.LEFT);
		// sets the PDFFont to the text
		underLineText.setPDFFont(labelFont);
		// sets the font size for the text
		underLineText.setFontSize(10);
		// sets the under line true
		underLineText.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(underLineText);

		// creates the PDFText
		PDFText strikeOutTextLabel = new PDFText("Text with Strikeout", mediaBox.x + 50, mediaBox.y + 165, mediaBox.width - 50, mediaBox.y + 165 + 25);
		// sets the alignment for the text
		strikeOutTextLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		strikeOutTextLabel.setPDFFont(labelFont);
		// sets the font size for the text
		strikeOutTextLabel.setFontSize(14);
		// sets the fill color for the text
		strikeOutTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the under line true
		strikeOutTextLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(strikeOutTextLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText strikeOutText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 190, mediaBox.width - 50, mediaBox.y + 190 + 50);
		// sets the alignment for the text
		strikeOutText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		strikeOutText.setPDFFont(labelFont);
		// sets the Font size for the text
		strikeOutText.setFontSize(10);
		// sets the strike out for the text
		strikeOutText.setStrikeOut(true);
		// adds the PDFText to the page
		page.addText(strikeOutText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText charSpacingTextLabel = new PDFText("Text with char spacing 5", mediaBox.x + 50, mediaBox.y + 240, mediaBox.width - 50, mediaBox.y + 240 + 25);
		// sets the alignment for the text
		charSpacingTextLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		charSpacingTextLabel.setPDFFont(labelFont);
		// sets the font size for the text
		charSpacingTextLabel.setFontSize(14);
		// sets the fill color for the text
		charSpacingTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the under line true
		charSpacingTextLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(charSpacingTextLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText charSpacingText = new PDFText(text2, mediaBox.x + 50, mediaBox.y + 265, mediaBox.width - 50, mediaBox.y + 265 + 70);
		// sets the alignment left
		charSpacingText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		charSpacingText.setPDFFont(labelFont);
		// sets the font size
		charSpacingText.setFontSize(10);
		// sets the char spacing for the text
		charSpacingText.setCharSpacing(5);
		// adds the PDFText to the page
		page.addText(charSpacingText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText wordSpacingTextLabel = new PDFText("Text with word spacing 10", mediaBox.x + 50, mediaBox.y + 325, mediaBox.width - 50, mediaBox.y + 325 + 25);
		// sets the alignment center
		wordSpacingTextLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		wordSpacingTextLabel.setPDFFont(labelFont);
		// sets the font size for the text
		wordSpacingTextLabel.setFontSize(14);
		// sets the fill color for the text
		wordSpacingTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true for the text
		wordSpacingTextLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(wordSpacingTextLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText wordSpacingText = new PDFText(text2, mediaBox.x + 50, mediaBox.y + 350, mediaBox.width - 50, mediaBox.y + 350 + 60);
		// sets the alignment left
		wordSpacingText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		wordSpacingText.setPDFFont(labelFont);
		// sets the font size for the text
		wordSpacingText.setFontSize(10);
		// sets the word spacing
		wordSpacingText.setWordSpacing(10);
		// adds the PDFText to the PDF
		page.addText(wordSpacingText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText horizontalScalingLabel = new PDFText("Text with horizontal scaling 200", mediaBox.x + 50, mediaBox.y + 410, mediaBox.width - 50, mediaBox.y + 410 + 25);
		// sets the alignment to the left
		horizontalScalingLabel.setAlignment(PDFText.CENTER);
		// sets the font for the text
		horizontalScalingLabel.setPDFFont(labelFont);
		// sets the font size for the text
		horizontalScalingLabel.setFontSize(14);
		// sets the fill color for the text
		horizontalScalingLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true
		horizontalScalingLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(horizontalScalingLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText horizontalScalingText = new PDFText(text2, mediaBox.x + 50, mediaBox.y + 435, mediaBox.width - 50, mediaBox.y + 435 + 60);
		// sets the alignment for the text
		horizontalScalingText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		horizontalScalingText.setPDFFont(labelFont);
		// sets the font size for the text
		horizontalScalingText.setFontSize(10);
		// sets the horizontal scaling for the text
		horizontalScalingText.setHorizontalScaling(200);
		// adds the PDFText to the page
		page.addText(horizontalScalingText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText riseTextLable = new PDFText("Text with superscript and subscript", mediaBox.x + 50, mediaBox.y + 495, mediaBox.width - 50, mediaBox.y + 495 + 25);
		// sets the alignment for the text
		riseTextLable.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		riseTextLable.setPDFFont(labelFont);
		// sets the font size for the text
		riseTextLable.setFontSize(14);
		// sets the fill color for the text
		riseTextLable.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true for the text
		riseTextLable.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(riseTextLable);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText subscript = new PDFText("Subscript  ", mediaBox.x + 50, mediaBox.y + 520);
		// sets the alignment for the text to left
		subscript.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		subscript.setPDFFont(labelFont);
		// sets the font size for the text
		subscript.setFontSize(14);
		// sets the RISE for the subscript for the text
		subscript.setRise(-7);
		// adds the PDFText to the page
		page.addText(subscript);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText normalText = new PDFText("Normal Text  ", mediaBox.x + 50 + subscript.getStringWidth(subscript.getText()), mediaBox.y + 520);
		// sets the alignment for the text to left
		normalText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		normalText.setPDFFont(labelFont);
		// sets the font size for the text
		normalText.setFontSize(14);
		// adds the PDFText to the page
		page.addText(normalText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText superscript = new PDFText("Superscript", mediaBox.x + 50 + subscript.getStringWidth(subscript.getText()) + normalText.getStringWidth(normalText.getText()), mediaBox.y + 520);
		// sets the alignment for the text
		superscript.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		superscript.setPDFFont(labelFont);
		// sets the font size for the text
		superscript.setFontSize(14);
		// sets the RISE for the text to make superscript
		superscript.setRise(7);
		// adds the text to the page
		page.addText(superscript);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText fontSizeLabel = new PDFText("Text with Font Size 20", mediaBox.x + 50, mediaBox.y + 560, mediaBox.width - 50, mediaBox.y + 560 + 25);
		// sets center alignment for the text
		fontSizeLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		fontSizeLabel.setPDFFont(labelFont);
		// sets the font size for the text
		fontSizeLabel.setFontSize(14);
		// sets the fill color for the text
		fontSizeLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true for the text
		fontSizeLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(fontSizeLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText fontSizeText = new PDFText("PDF is a file format used to represent a document.", mediaBox.x + 50, mediaBox.y + 585 + 10, mediaBox.width - 50, mediaBox.y + 585 + 10 + 40);
		// sets the alignment to the left
		fontSizeText.setAlignment(PDFText.LEFT);
		// sets the PDFFont to the text
		fontSizeText.setPDFFont(labelFont);
		// sets the font size for the text
		fontSizeText.setFontSize(20);
		// adds the PDFText to the page
		page.addText(fontSizeText);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText outlineTextLabel = new PDFText("Text with Outline color red and Fill color green", mediaBox.x + 50, mediaBox.y + 635, mediaBox.width - 50, mediaBox.y + 635 + 25);
		// sets the alignment to the center
		outlineTextLabel.setAlignment(PDFText.CENTER);
		// sets the PDFFont for the text
		outlineTextLabel.setPDFFont(labelFont);
		// sets the font size for the text
		outlineTextLabel.setFontSize(14);
		// sets the fill color for the text
		outlineTextLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		// sets the underline true
		outlineTextLabel.setUnderLine(true);
		// adds the PDFText to the page
		page.addText(outlineTextLabel);

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText outlineText = new PDFText("PDF is a file format used to represent a document.", mediaBox.x + 50, mediaBox.y + 660 + 10, mediaBox.width - 50, mediaBox.y + 660 + 10 + 40);
		// sets the alignment for the text
		outlineText.setAlignment(PDFText.LEFT);
		// sets the PDFFont for the text
		outlineText.setPDFFont(labelFont);
		// sets the Font size for the text
		outlineText.setFontSize(30);
		// sets the outline mode to true, to draw outline color
		outlineText.setOutlineMode(true);
		// sets the fill color
		outlineText.setFillColor(Color.green);
		// sets the outline color
		outlineText.setOutlineColor(HEADER_TEXT_FILL_COLOR);
		// adds the PDFText to the page
		page.addText(outlineText);
		return page;
	}

	// creates the PDFFont page
	private Page createPDFFontPage() throws IOException
	{
		String text = "" +
		"PDF is a file format used to represent a document in a manner independent of the " +
		"application software, hardware, and operating system used to create it. A PDF file " +
		"contains a PDF document and other supporting data." +
		"A PDF document contains one or more pages. Each page in the document may " +
		"contain any combination of text, graphics, and images in a device- and resolution-independent " +
		"format. This is the page description. A PDF document may also" +
		"contain information possible only in an electronic representation, such as hypertext " +
		"links, sound, and movies." +
		"In addition to a document, a PDF file contains the version of the PDF specification " +
		"used in the file and information about the location of important structures in the " +
		"file." +
		"To understand PDF, it is important to understand how PDF documents will be " +
		"produced and used. As PDF documents and applications that read PDF files " +
		"become more prevalent, new ways of creating and using PDF files will be " +
		"invented. This is one of the goals of this book to make the file format accessible " +
		"so that application developers can expand on the ideas behind PDF and the " +
		"applications that initially support it.";

		// create the page
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	labelPDFText = new PDFText("ElegantJ PDF Font Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		labelPDFText.setPDFFont(labelFont);
		labelPDFText.setFontSize(18);
		labelPDFText.setFillColor(HEADER_TEXT_FILL_COLOR);
		labelPDFText.setAlignment(PDFText.CENTER);
		labelPDFText.setUnderLine(true);
		page.addText(labelPDFText);

		PDFText trueTypeFontLabel = new PDFText("Text with True Type arial.ttf PDFFont with embedded and subset", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		trueTypeFontLabel.setAlignment(PDFText.CENTER);
		trueTypeFontLabel.setPDFFont(labelFont);
		trueTypeFontLabel.setFontSize(14);
		trueTypeFontLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		trueTypeFontLabel.setUnderLine(true);
		page.addText(trueTypeFontLabel);

		PDFText trueTypeFontText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 115, mediaBox.width - 50, mediaBox.y + 115 + 200);
		trueTypeFontText.setAlignment(PDFText.JUSTIFY);
		trueTypeFontText.setPDFFont(trueTypeFont);
		trueTypeFontText.setFontSize(12);
		page.addText(trueTypeFontText);

		PDFText type1FontLabel = new PDFText("Text with Type1 PDFFont with embedded", mediaBox.x + 50, mediaBox.y + 330, mediaBox.width - 50, mediaBox.y + 330 + 25);
		type1FontLabel.setAlignment(PDFText.CENTER);
		type1FontLabel.setPDFFont(labelFont);
		type1FontLabel.setFontSize(14);
		type1FontLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		type1FontLabel.setUnderLine(true);
		page.addText(type1FontLabel);

		PDFText type1FontText = new PDFText(text, mediaBox.x + 50, mediaBox.y + 355, mediaBox.width - 50, mediaBox.y + 355 + 200);
		type1FontText.setAlignment(PDFText.JUSTIFY);
		type1FontText.setPDFFont(type1Font);
		type1FontText.setFontSize(12);
		page.addText(type1FontText);

		String cjkText = 	"" +
		"؃tHgpbNAcrobat Reader 4.0 Ŏgp܂Bǂ̌Acrobat Reader 4.0 łAiȑ́jAiɑ́jA{Aъ؍iCJK j̃eLXg̓Adobe Portable Document Format iPDF jt@C\邱Ƃł܂BPDF t@C̍쐬҂CJK tHg𕶏ɖߍłƁAʂȃ\tgEFAǉȂĂAǂ̃VXêǂ̌ Reader 4.0 gĂACJK eLXg\邱Ƃł܂BPDF t@C̍쐬҂CJK tHggĂ邯ǂACJK tHg𕶏ɖߍłȂꍇ́AlCeBuVXeȊO PDF t@C\邽߂ɂ́AK؂ȓ؃tHgɃANZXKv܂B̂߂ɂ́A Acrobat Reader Ŏgp؃tHgpbNCXg[Kv܂B.";
		PDFText trueTypeCJKFontLabel = new PDFText("Text with True Type Japanese Font(hgrgep.ttf) with IDENTITY_H encoding", mediaBox.x + 50, mediaBox.y + 570, mediaBox.width - 50, mediaBox.y + 570 + 25);
		trueTypeCJKFontLabel.setAlignment(PDFText.CENTER);
		trueTypeCJKFontLabel.setPDFFont(labelFont);
		trueTypeCJKFontLabel.setFontSize(14);
		trueTypeCJKFontLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		trueTypeCJKFontLabel.setUnderLine(true);
		page.addText(trueTypeCJKFontLabel);

		PDFText trueTypeCJKFontText = new PDFText(cjkText, mediaBox.x + 50, mediaBox.y + 595, mediaBox.width - 50, mediaBox.y + 595 + 200);
		trueTypeCJKFontText.setAlignment(PDFText.JUSTIFY);
		trueTypeCJKFontText.setPDFFont(trueTypeCJKFont);
		trueTypeCJKFontText.setFontSize(12);
		page.addText(trueTypeCJKFontText);

		return page;
	}

	// creates the line page
	private Page createPDFLinePage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	labelPDFText = new PDFText("ElegantJ PDF Line Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		labelPDFText.setPDFFont(labelFont);
		labelPDFText.setFontSize(18);
		labelPDFText.setFillColor(HEADER_TEXT_FILL_COLOR);
		labelPDFText.setAlignment(PDFText.CENTER);
		labelPDFText.setUnderLine(true);
		page.addText(labelPDFText);

		PDFText lineLabel = new PDFText("PDFLine with round caps & joins, dash and line width is 20", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		lineLabel.setAlignment(PDFText.CENTER);
		lineLabel.setPDFFont(labelFont);
		lineLabel.setFontSize(14);
		lineLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		lineLabel.setUnderLine(true);
		page.addText(lineLabel);

		// creates the PDFLine object with x1, y1, x2, y2
		PDFLine pdfLine = new PDFLine(150, 150, 500, 500);
		// sets the ROUND CAPS for the both end of line
		pdfLine.setCapStyle(PDFGraphicsObject.ROUND_CAPS);
		// sets the dash pattern for the dashed line
		pdfLine.setDashPattern(20, 40);
		// sets the join style for the line
		pdfLine.setJoinStyle(PDFGraphicsObject.ROUND_JOINS);
		// sets the line color
		pdfLine.setLineColor(createRandomColor());
		// sets the line width
		pdfLine.setLineWidth(20);
		// adds the line to the page
		page.addGraphics(pdfLine);
		return page;
	}

	// creates the Rectangle page
	private Page createPDFRectanglePage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Rectangle Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFText rectangleLabel = new PDFText("PDFRectangle with fill color, outline color, outline width and join style", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		rectangleLabel.setAlignment(PDFText.CENTER);
		rectangleLabel.setPDFFont(labelFont);
		rectangleLabel.setFontSize(14);
		rectangleLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		rectangleLabel.setUnderLine(true);
		page.addText(rectangleLabel);

		// creates the PDFRectangle object with x, y, width and height
		PDFRectangle pdfRectangle1 = new PDFRectangle(100, 115, mediaBox.width - 200, 100);
		// sets the fill color for the PDFRectangle
		pdfRectangle1.setFillColor(createRandomColor());
		// sets the fill mode true, to fill the rectangle
		pdfRectangle1.setFillMode(true);
		// sets the outline color for the rectangle
		pdfRectangle1.setOutlineColor(createRandomColor());
		// sets the outline width for the rectangle
		pdfRectangle1.setOutlineWidth(5);
		// sets the round joins for the rectangle
		pdfRectangle1.setJoinStyle(PDFGraphicsObject.ROUND_JOINS);
		// adds the PDFRectangle to the page
		page.addGraphics(pdfRectangle1);

		PDFText rectangleLabel2 = new PDFText("PDFRectangle with CHECK, CIRCLE, HORIZONTAL LINE Patterns", mediaBox.x + 50, mediaBox.y + 235, mediaBox.width - 50, mediaBox.y + 235 + 25);
		rectangleLabel2.setAlignment(PDFText.CENTER);
		rectangleLabel2.setPDFFont(labelFont);
		rectangleLabel2.setFontSize(14);
		rectangleLabel2.setFillColor(HEADER_TEXT_FILL_COLOR);
		rectangleLabel2.setUnderLine(true);
		page.addText(rectangleLabel2);

		// creates the PDFPattern
		PDFPattern pdfPattern = new PDFPattern();
		// sets the pattern style
		pdfPattern.setPatternStyle(PDFPattern.CHECK_PATTERN);
		// sets the background for the pattern
		pdfPattern.setBackground(createRandomColor());
		// sets the foreground for the pattern
		pdfPattern.setForeground(createRandomColor());

		// clones the PDFRectangle
		PDFRectangle pdfRectangleCheck = (PDFRectangle)pdfRectangle1.clone();
		pdfRectangleCheck.setOutlineWidth(1);
		pdfRectangleCheck.setPattern(pdfPattern);
		pdfRectangleCheck.setX(50);
		pdfRectangleCheck.setY(260);
		pdfRectangleCheck.setWidth(155);
		pdfRectangleCheck.setHeight(150);
		page.addGraphics(pdfRectangleCheck);

		PDFRectangle pdfRectangleCircle = (PDFRectangle)pdfRectangleCheck.clone();
		pdfRectangleCircle.setX(50 + 155 + 10);
		// sets the pattern style to the CIRCLE_PATTERN
		pdfRectangleCircle.getPattern().setPatternStyle(PDFPattern.CIRCLE_PATTERN);
		// sets the background for the pattern
		pdfRectangleCircle.getPattern().setBackground(createRandomColor());
		// sets the foreground for the pattern
		pdfRectangleCircle.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangleCircle);

		PDFRectangle pdfRectangleHorzLine = (PDFRectangle)pdfRectangleCheck.clone();
		pdfRectangleHorzLine.setX(50 + 155 + 10 + 155 + 10);
		// sets the pattern style to HORIZONTAL_LINE_PATTERN
		pdfRectangleHorzLine.getPattern().setPatternStyle(PDFPattern.HORIZONTAL_LINE_PATTERN);
		// sets the background for the pattern
		pdfRectangleHorzLine.getPattern().setBackground(createRandomColor());
		// sets the foreground for the patter
		pdfRectangleHorzLine.getPattern().setForeground(createRandomColor());
		// adds the PDFRectangle to the page
		page.addGraphics(pdfRectangleHorzLine);

		PDFText rectangleLabel3 = new PDFText("PDFRectangle with INCLINED LINE, OVAL, and STAR Patterns", mediaBox.x + 50, mediaBox.y + 440, mediaBox.width - 50, mediaBox.y + 440 + 25);
		rectangleLabel3.setAlignment(PDFText.CENTER);
		rectangleLabel3.setPDFFont(labelFont);
		rectangleLabel3.setFontSize(14);
		rectangleLabel3.setFillColor(HEADER_TEXT_FILL_COLOR);
		rectangleLabel3.setUnderLine(true);
		page.addText(rectangleLabel3);

		PDFRectangle pdfRectangleIncLine = (PDFRectangle)pdfRectangleCheck.clone();
		pdfRectangleIncLine.setX(50);
		pdfRectangleIncLine.setY(465);
		// sets the PDFPattern to the INCLINED_LINE_PATTERN
		pdfRectangleIncLine.getPattern().setPatternStyle(PDFPattern.INCLINED_LINE_PATTERN);
		pdfRectangleIncLine.getPattern().setBackground(createRandomColor());
		pdfRectangleIncLine.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangleIncLine);

		PDFRectangle pdfRectangleOval = (PDFRectangle)pdfRectangleIncLine.clone();
		pdfRectangleOval.setX(50 + 155 + 10);
		// sets the PDFPattern to the OVAL_PATTERN
		pdfRectangleOval.getPattern().setPatternStyle(PDFPattern.OVAL_PATTERN);
		pdfRectangleOval.getPattern().setBackground(createRandomColor());
		pdfRectangleOval.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangleOval);

		PDFRectangle pdfRectangleStar = (PDFRectangle)pdfRectangleIncLine.clone();
		pdfRectangleStar.setX(50 + 155 + 10 + 155 + 10);
		// sets the PDFPattern to the STAR_PATTERN
		pdfRectangleStar.getPattern().setPatternStyle(PDFPattern.STAR_PATTERN);
		pdfRectangleStar.getPattern().setBackground(createRandomColor());
		pdfRectangleStar.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangleStar);

		PDFText rectangleLabel4 = new PDFText("PDFRectangle with VERTICAL LINE and Image as a Patterns", mediaBox.x + 50, mediaBox.y + 650, mediaBox.width - 50, mediaBox.y + 650 + 25);
		rectangleLabel4.setAlignment(PDFText.CENTER);
		rectangleLabel4.setPDFFont(labelFont);
		rectangleLabel4.setFontSize(14);
		rectangleLabel4.setFillColor(HEADER_TEXT_FILL_COLOR);
		rectangleLabel4.setUnderLine(true);
		page.addText(rectangleLabel4);

		PDFRectangle pdfRectangleVerLine = (PDFRectangle)pdfRectangleCheck.clone();
		pdfRectangleVerLine.setX(50);
		pdfRectangleVerLine.setY(675);
		pdfRectangleVerLine.setHeight(100);
		pdfRectangleVerLine.setWidth(250);
		// sets the PDFPattern to the VERTICAL_LINE_PATTERN
		pdfRectangleVerLine.getPattern().setPatternStyle(PDFPattern.VERTICAL_LINE_PATTERN);
		pdfRectangleVerLine.getPattern().setBackground(createRandomColor());
		pdfRectangleVerLine.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangleVerLine);

		PDFRectangle pdfRectangleImage = (PDFRectangle)pdfRectangleCheck.clone();
		pdfRectangleImage.setX(50 + 10 + 200);
		pdfRectangleImage.setY(675);
		pdfRectangleImage.setHeight(100);
		pdfRectangleImage.setWidth(285);
		// sets the image as a pattern
		pdfRectangleImage.getPattern().setImage(pdfImage);
		page.addGraphics(pdfRectangleImage);
		return page;
	}

	// creates the circle page
	private Page createPDFCirclePage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Circle Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFText circleLabel = new PDFText("PDFCircle with fill color, outline color and outline width", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		circleLabel.setAlignment(PDFText.CENTER);
		circleLabel.setPDFFont(labelFont);
		circleLabel.setFontSize(14);
		circleLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		circleLabel.setUnderLine(true);
		page.addText(circleLabel);

		// creeates the PDFCircle with x, y and radius
		PDFCircle pdfCircle1 = new PDFCircle(mediaBox.width/2, mediaBox.y + 115 + 50, 50);
		// sets the fill color for the PDFCircle
		pdfCircle1.setFillColor(createRandomColor());
		// sets the fill mode true
		pdfCircle1.setFillMode(true);
		// sets the outline color
		pdfCircle1.setOutlineColor(createRandomColor());
		// sets the outline width
		pdfCircle1.setOutlineWidth(5);
		// adds the PDFCircle to the page
		page.addGraphics(pdfCircle1);

		PDFText circleLabel2 = new PDFText("PDFCircle with some patterns", mediaBox.x + 50, mediaBox.y + 235, mediaBox.width - 50, mediaBox.y + 235 + 25);
		circleLabel2.setAlignment(PDFText.CENTER);
		circleLabel2.setPDFFont(labelFont);
		circleLabel2.setFontSize(14);
		circleLabel2.setFillColor(HEADER_TEXT_FILL_COLOR);
		circleLabel2.setUnderLine(true);
		page.addText(circleLabel2);

		// creates the PDFPattern
		PDFPattern pdfPattern = new PDFPattern();
		// sets the Pattern style to CHECK_PATTERN
		pdfPattern.setPatternStyle(PDFPattern.CHECK_PATTERN);
		// sets the background for the pattern
		pdfPattern.setBackground(createRandomColor());
		// sets the foreground for the pattern
		pdfPattern.setForeground(createRandomColor());

		// clones the PDFCircle
		PDFCircle pdfCircleCheck = (PDFCircle)pdfCircle1.clone();
		pdfCircleCheck.setOutlineWidth(1);
		pdfCircleCheck.setPattern(pdfPattern);
		// sets the PDFPattern to the PDFCircle
		pdfCircleCheck.setX(50 + 75);
		// sets the Y value for the circle
		pdfCircleCheck.setY(mediaBox.y + 50 + 290);
		// sets the radius for the circle
		pdfCircleCheck.setRadius(75);
		// adds the PDFCircle to the page
		page.addGraphics(pdfCircleCheck);

		PDFCircle pdfCircleCircle = (PDFCircle)pdfCircleCheck.clone();
		pdfCircleCircle.setX(50 + 75 + 75 + 20 + 75);
		// sets the pattern style to CIRCLE_PATTERN
		pdfCircleCircle.getPattern().setPatternStyle(PDFPattern.CIRCLE_PATTERN);
		pdfCircleCircle.getPattern().setBackground(createRandomColor());
		pdfCircleCircle.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfCircleCircle);

		PDFCircle pdfCircleHorzLine = (PDFCircle)pdfCircleCheck.clone();
		pdfCircleHorzLine.setX(50 + 75 + 75 + 20 + 75 + 75 + 25 + 75);
		// sets the pattern style to HORIZONTAL_LINE_PATTERN
		pdfCircleHorzLine.getPattern().setPatternStyle(PDFPattern.HORIZONTAL_LINE_PATTERN);
		pdfCircleHorzLine.getPattern().setBackground(createRandomColor());
		pdfCircleHorzLine.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfCircleHorzLine);

		PDFCircle pdfCircleVertLine = (PDFCircle)pdfCircleCheck.clone();
		// sets the pattern style to LINE_PATTERN
		pdfCircleVertLine.getPattern().setPatternStyle(PDFPattern.VERTICAL_LINE_PATTERN);
		pdfCircleVertLine.setX(50 + 75);
		pdfCircleVertLine.setY(mediaBox.y + 50 + 460);
		pdfCircleVertLine.setRadius(75);
		page.addGraphics(pdfCircleVertLine);

		PDFCircle pdfOvalCircle = (PDFCircle)pdfCircleVertLine.clone();
		pdfOvalCircle.setX(50 + 75 + 75 + 20 + 75);
		// sets the pattern style to OVAL_PATTERN
		pdfOvalCircle.getPattern().setPatternStyle(PDFPattern.OVAL_PATTERN);
		pdfOvalCircle.getPattern().setBackground(createRandomColor());
		pdfOvalCircle.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfOvalCircle);

		PDFCircle pdfCircleStar = (PDFCircle)pdfCircleVertLine.clone();
		pdfCircleStar.setX(50 + 75 + 75 + 20 + 75 + 75 + 25 + 75);
		// sets the pattern style to STAR_PATTERN
		pdfCircleStar.getPattern().setPatternStyle(PDFPattern.STAR_PATTERN);
		pdfCircleStar.getPattern().setBackground(createRandomColor());
		pdfCircleStar.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfCircleStar);
		return page;
	}

	// creates the PDFOvalPage
	private Page createPDFOvalPage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Oval Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFText ovalLabel = new PDFText("PDFOval with fill color, outline color and outline width", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		ovalLabel.setAlignment(PDFText.CENTER);
		ovalLabel.setPDFFont(labelFont);
		ovalLabel.setFontSize(14);
		ovalLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		ovalLabel.setUnderLine(true);
		page.addText(ovalLabel);

		// creates the PDFOval with x, y, width and height
		PDFOval pdfOval1 = new PDFOval(mediaBox.width/2, mediaBox.y + 115 + 50, 100, 50);
		// sets the fill color
		pdfOval1.setFillColor(createRandomColor());
		// sets the fill mode true
		pdfOval1.setFillMode(true);
		// sets the outline color for the oval
		pdfOval1.setOutlineColor(createRandomColor());
		// sets the outline width for the oval
		pdfOval1.setOutlineWidth(5);
		// adds the PDFOval to the page
		page.addGraphics(pdfOval1);

		PDFText ovalLabel2 = new PDFText("PDFOval with some patterns", mediaBox.x + 50, mediaBox.y + 235, mediaBox.width - 50, mediaBox.y + 235 + 25);
		ovalLabel2.setAlignment(PDFText.CENTER);
		ovalLabel2.setPDFFont(labelFont);
		ovalLabel2.setFontSize(14);
		ovalLabel2.setFillColor(HEADER_TEXT_FILL_COLOR);
		ovalLabel2.setUnderLine(true);
		page.addText(ovalLabel2);

		// creates the PDFPattern
		PDFPattern pdfPattern = new PDFPattern();
		// sets the pattern style to CHECK_PATTERN
		pdfPattern.setPatternStyle(PDFPattern.CHECK_PATTERN);
		// sets the background for the PDFPattern
		pdfPattern.setBackground(createRandomColor());
		// sets the foreground for the PDFPattern
		pdfPattern.setForeground(createRandomColor());

		// clones the PDFOval
		PDFOval pdfOvalCheck = (PDFOval)pdfOval1.clone();
		pdfOvalCheck.setOutlineWidth(1);
		// sets the PDFPattern for the PDFOval
		pdfOvalCheck.setPattern(pdfPattern);
		// sets the X for the PDFOval
		pdfOvalCheck.setX(50 + 75);
		// sets the Y for the PDFOval
		pdfOvalCheck.setY(mediaBox.y + 50 + 270);
		// sets the width for the PDFOval
		pdfOvalCheck.setWidth(125);
		// sets the height for the PDFOval
		pdfOvalCheck.setHeight(75);
		// adds the PDFOval to the page
		page.addGraphics(pdfOvalCheck);

		PDFOval pdfOvalCircle = (PDFOval)pdfOvalCheck.clone();
		pdfOvalCircle.setX(50 + 75 + 75 + 20 + 75);
		// sets the PDFOval pattern's to the CIRCLE_PATTERN
		pdfOvalCircle.getPattern().setPatternStyle(PDFPattern.CIRCLE_PATTERN);
		pdfOvalCircle.getPattern().setBackground(createRandomColor());
		pdfOvalCircle.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfOvalCircle);

		PDFOval pdfOvalHorzLine = (PDFOval)pdfOvalCheck.clone();
		pdfOvalHorzLine.setX(50 + 75 + 75 + 20 + 75 + 75 + 25 + 75);
		// sets the PDFOval pattern's to the HORIZONTAL_LINE_PATTERN
		pdfOvalHorzLine.getPattern().setPatternStyle(PDFPattern.HORIZONTAL_LINE_PATTERN);
		pdfOvalHorzLine.getPattern().setBackground(createRandomColor());
		pdfOvalHorzLine.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfOvalHorzLine);

		PDFOval pdfOvalVertLine = (PDFOval)pdfOvalCheck.clone();
		// sets the PDFOval pattern's to the VERTICAL_LINE_PATTERN
		pdfOvalVertLine.getPattern().setPatternStyle(PDFPattern.VERTICAL_LINE_PATTERN);
		pdfOvalVertLine.setX(50 + 75);
		pdfOvalVertLine.setY(mediaBox.y + 50 + 440);
		pdfOvalVertLine.setWidth(125);
		pdfOvalVertLine.setHeight(75);
		page.addGraphics(pdfOvalVertLine);

		PDFOval pdfOvalOval = (PDFOval)pdfOvalVertLine.clone();
		pdfOvalOval.setX(50 + 75 + 75 + 20 + 75);
		// sets the PDFOval pattern's to the OVAL_PATTERN
		pdfOvalOval.getPattern().setPatternStyle(PDFPattern.OVAL_PATTERN);
		pdfOvalOval.getPattern().setBackground(createRandomColor());
		pdfOvalOval.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfOvalOval);

		PDFOval pdfOvalStar = (PDFOval)pdfOvalVertLine.clone();
		pdfOvalStar.setX(50 + 75 + 75 + 20 + 75 + 75 + 25 + 75);
		// sets the PDFOval pattern's to the STAR_PATTERN
		pdfOvalStar.getPattern().setPatternStyle(PDFPattern.STAR_PATTERN);
		pdfOvalStar.getPattern().setBackground(createRandomColor());
		pdfOvalStar.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfOvalStar);
		return page;
	}

	// creates the PDFArc page
	private Page createPDFArcPage() throws IOException
	{
		// creates page
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Arc Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		// creates PDFText
		PDFText arcLabel = new PDFText("PDFArc with fill color, outline color and outline width", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		arcLabel.setAlignment(PDFText.CENTER);
		arcLabel.setPDFFont(labelFont);
		arcLabel.setFontSize(14);
		arcLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		arcLabel.setUnderLine(true);
		page.addText(arcLabel);

		// creates the PDFArc object with x1, y1, x2, y2, cx1, cy1, cx2, cy2
		PDFArc pdfArc1 = new PDFArc(100, 130, mediaBox.width - 10, 130, 200, 170, 350, 170);
		// sets the fill color
		pdfArc1.setFillColor(createRandomColor());
		// sets the fill mode true
		pdfArc1.setFillMode(true);
		// sets the outline color
		pdfArc1.setOutlineColor(createRandomColor());
		// sets the outline width to 5
		pdfArc1.setOutlineWidth(5);
		// adds the PDFArc to the page
		page.addGraphics(pdfArc1);

		PDFText arcLabel2 = new PDFText("PDFArc with star pattern", mediaBox.x + 50, mediaBox.y + 190, mediaBox.width - 50, mediaBox.y + 190 + 25);
		arcLabel2.setAlignment(PDFText.CENTER);
		arcLabel2.setPDFFont(labelFont);
		arcLabel2.setFontSize(14);
		arcLabel2.setFillColor(HEADER_TEXT_FILL_COLOR);
		arcLabel2.setUnderLine(true);
		page.addText(arcLabel2);

		// creates the PDFPattern
		PDFPattern pdfPattern = new PDFPattern();
		// sets the background for the PDFPattern
		pdfPattern.setBackground(createRandomColor());
		// sets the foreground for the PDFPattern
		pdfPattern.setForeground(createRandomColor());

		PDFArc pdfArc2 = new PDFArc(mediaBox.width/2, 225, mediaBox.width/2, 500, mediaBox.width - 50, 300, mediaBox.width - 50, 400);
		// sets the PDFPattern
		pdfArc2.setPattern(pdfPattern);
		// sets the outline color
		pdfArc2.setOutlineColor(createRandomColor());
		// sets the ouline width to 5
		pdfArc2.setOutlineWidth(5);
		// adds the PDFArc to the page
		page.addGraphics(pdfArc2);
		return page;
	}

	// creates the polygon page
	private Page createPDFPolygonPage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Polygon Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFText polygonLabel = new PDFText("PDFPolygon with fill color, outline color and outline width", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		polygonLabel.setAlignment(PDFText.CENTER);
		polygonLabel.setPDFFont(labelFont);
		polygonLabel.setFontSize(14);
		polygonLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		polygonLabel.setUnderLine(true);
		page.addText(polygonLabel);

		int x[] = new int[]{100 + 50, 150 + 50, 300 + 50, 350 + 50, 400 + 50, 100 + 50};
		int y[] = new int[]{180, 130, 130, 180, 310, 310};
		int nPoints = 6;

		// create the PDFPolygon from the x array, y array and n points
		PDFPolygon pdfPolygon = new PDFPolygon(x, y, nPoints);
		// sets the fill color for the PDFPolygon
		pdfPolygon.setFillColor(createRandomColor());
		// sets the fill mode true for the polygon
		pdfPolygon.setFillMode(true);
		// sets the outline color for the polygon
		pdfPolygon.setOutlineColor(createRandomColor());
		// sets the outline width for the polygon
		pdfPolygon.setOutlineWidth(5);
		// adds the PDFPolygon to the page
		page.addGraphics(pdfPolygon);

		PDFText polygonLabel2 = new PDFText("PDFPolygon with check pattern", mediaBox.x + 50, mediaBox.y + 390, mediaBox.width - 50, mediaBox.y + 390 + 25);
		polygonLabel2.setAlignment(PDFText.CENTER);
		polygonLabel2.setPDFFont(labelFont);
		polygonLabel2.setFontSize(14);
		polygonLabel2.setFillColor(HEADER_TEXT_FILL_COLOR);
		polygonLabel2.setUnderLine(true);
		page.addText(polygonLabel2);

		// creates the PDFPattern
		PDFPattern pdfPattern = new PDFPattern();
		// sets the pattern style to CHECK_PATTERN
		pdfPattern.setPatternStyle(PDFPattern.CHECK_PATTERN);
		// sets the background for the PDFPattern
		pdfPattern.setBackground(createRandomColor());
		// sets the foreground for the PDFPattern
		pdfPattern.setForeground(createRandomColor());

		int x1[] = new int[]{100 + 50, 150 + 50, 300 + 50, 350+ 50, 400 + 50, 100 + 50};
		int y1[] = new int[]{480, 430, 430, 480, 610, 610};
		int nPoints1 = 6;

		// creates the PDFPolygon for the x array, y array and n points
		PDFPolygon pdfPolygon2 = new PDFPolygon(x1, y1, nPoints);
		// sets the patter to the PDFPolygon
		pdfPolygon2.setPattern(pdfPattern);
		// sets the outline color for the polygon
		pdfPolygon2.setOutlineColor(createRandomColor());
		// sets the outline width for the polygon
		pdfPolygon2.setOutlineWidth(5);
		// adds the polygon to the page
		page.addGraphics(pdfPolygon2);
		return page;
	}

	// creates the patterns page1
	private Page createPDFPatternPage1() throws IOException
	{
		// creates the page
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Pattern Demo 1", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFText patternLabel = new PDFText("PDFPattern with Text", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		patternLabel.setAlignment(PDFText.CENTER);
		patternLabel.setPDFFont(labelFont);
		patternLabel.setFontSize(14);
		patternLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		patternLabel.setUnderLine(true);
		page.addText(patternLabel);

		// creates the PDFPattern
		PDFPattern pattern = new PDFPattern();
		// sets the Pattern style to CHECK_PATTER
		pattern.setPatternStyle(PDFPattern.CHECK_PATTERN);
		// sets the background to the pattern
		pattern.setBackground(createRandomColor());
		// sets the foreground to the pattern
		pattern.setForeground(createRandomColor());

		// creates the PDFText with UpperLeftX, UpperLeftY, LowerRightX, LowerRightY
		PDFText text1 = new PDFText("Patterns", mediaBox.x, mediaBox.y + 120, mediaBox.width, mediaBox.y + 200 + 150);
		// sets the alignment for the PDFText
		text1.setAlignment(PDFText.CENTER);
		// sets the PDFFont to the text
		text1.setPDFFont(trueTypeFont);
		// sets the text font size
		text1.setFontSize(100);
		// sets the PDFPattern to the text
		text1.setPattern(pattern);
		// adds the text to the page
		page.addText(text1);

		// clones the PDFText object
		PDFText text2 = (PDFText)text1.clone();
		// sets teh Upper left y
		text2.setUpperLeftY(220);
		// sets the lower right y
		text2.setLowerRightY(220 + 150);
		// sets the pattern style to the CIRCLE_PATTERN
		text2.getPattern().setPatternStyle(PDFPattern.CIRCLE_PATTERN);
		// sets the pattern background
		text2.getPattern().setBackground(createRandomColor());
		// sets the pattern foreground
		text2.getPattern().setForeground(createRandomColor());
		// adds the text to the page
		page.addText(text2);

		PDFText text3 = (PDFText)text2.clone();
		text3.setUpperLeftY(320);
		text3.setLowerRightY(320 + 150);
		// sets the pattern style to the HORIZONTAL_LINE_PATTERN
		text3.getPattern().setPatternStyle(PDFPattern.HORIZONTAL_LINE_PATTERN);
		text3.getPattern().setBackground(createRandomColor());
		text3.getPattern().setForeground(createRandomColor());
		page.addText(text3);

		PDFText text4 = (PDFText)text2.clone();
		text4.setUpperLeftY(420);
		text4.setLowerRightY(420 + 150);
		// sets the pattern style to the INCLINED_LINE_PATTERN
		text4.getPattern().setPatternStyle(PDFPattern.INCLINED_LINE_PATTERN);
		text4.getPattern().setBackground(createRandomColor());
		text4.getPattern().setForeground(createRandomColor());
		page.addText(text4);

		PDFText text5 = (PDFText)text2.clone();
		text5.setUpperLeftY(520);
		text5.setLowerRightY(520 + 150);
		// sets the pattern style to the OVAL_PATTERN
		text5.getPattern().setPatternStyle(PDFPattern.OVAL_PATTERN);
		text5.getPattern().setBackground(createRandomColor());
		text5.getPattern().setForeground(createRandomColor());
		page.addText(text5);

		PDFText text6 = (PDFText)text2.clone();
		text6.setUpperLeftY(620);
		text6.setLowerRightY(620 + 150);
		// sets the pattern style to the STAR_PATTERN
		text6.getPattern().setPatternStyle(PDFPattern.STAR_PATTERN);
		text6.getPattern().setBackground(createRandomColor());
		text6.getPattern().setForeground(createRandomColor());
		page.addText(text6);

		PDFText text7 = (PDFText)text2.clone();
		text7.setUpperLeftY(720);
		text7.setLowerRightY(720 + 150);
		text7.getPattern().setImage(pdfImage);
		page.addText(text7);
		return page;
	}

	// creates the patterns page2
	private Page createPDFPatternPage2() throws IOException
	{
		// creates the page
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Pattern Demo 2", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		// creates the text object
		PDFText patternLabel = new PDFText("PDFPattern with Graphics", mediaBox.x + 50, mediaBox.y + 90, mediaBox.width - 50, mediaBox.y + 90 + 25);
		patternLabel.setAlignment(PDFText.CENTER);
		patternLabel.setPDFFont(labelFont);
		patternLabel.setFontSize(14);
		patternLabel.setFillColor(HEADER_TEXT_FILL_COLOR);
		patternLabel.setUnderLine(true);
		page.addText(patternLabel);

		// creates the PDFPattern
		PDFPattern pattern = new PDFPattern();
		// sets the star pattern style
		pattern.setPatternStyle(PDFPattern.STAR_PATTERN);
		// sets the background for the pattern
		pattern.setBackground(createRandomColor());
		// sets the foreground for the pattern
		pattern.setForeground(createRandomColor());

		// creates the PDFRectangle
		PDFRectangle pdfRectangle1 = new PDFRectangle(100, 115, mediaBox.width - 200, 100);
		pdfRectangle1.setOutlineColor(createRandomColor());
		pdfRectangle1.setOutlineWidth(1);
		// sets the join style
		pdfRectangle1.setJoinStyle(PDFGraphicsObject.ROUND_JOINS);
		// sets the pattern
		pdfRectangle1.setPattern(pattern);
		page.addGraphics(pdfRectangle1);

		PDFRectangle pdfRectangle2 = (PDFRectangle)pdfRectangle1.clone();
		pdfRectangle2.setY(220);
		// sets the pattern to the CHECK
		pdfRectangle2.getPattern().setPatternStyle(PDFPattern.CHECK_PATTERN);
		pdfRectangle2.getPattern().setBackground(createRandomColor());
		pdfRectangle2.getPattern().setForeground(createRandomColor());
		page.addGraphics(pdfRectangle2);

		PDFPattern pattern2 = new PDFPattern();
		// sets the pattern to the OVAL_PATTERN
		pattern2.setPatternStyle(PDFPattern.OVAL_PATTERN);
		pattern2.setBackground(createRandomColor());
		pattern2.setForeground(createRandomColor());

		// creates the PDFCircle
		PDFCircle pdfCircle1 = new PDFCircle(mediaBox.width/2, 500, 75);
		// sets the pattern
		pdfCircle1.setPattern(pattern2);
		// sets the outline width
		pdfCircle1.setOutlineWidth(1);
		// adds the PDFCircle to the page
		page.addGraphics(pdfCircle1);

		// creates the PDFCircle by cloning
		PDFCircle pdfCircle2 = (PDFCircle)pdfCircle1.clone();
		// sets the Y value for the PDFCircle
		pdfCircle2.setY(670);
		// sets the PDFImage as a pattern
		pdfCircle2.getPattern().setImage(pdfImage);
		// adds the PDFCircle to the page
		page.addGraphics(pdfCircle2);
		return page;
	}

	// creates the annotation page 1
	private Page createPDFAnnotationPage1() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Rubber Stamp Annotation Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		// creates the rubber stamp annotation with text, x, y, width and height and font
		PDFRubberStampAnnotation rubberStampAnnotation1 = new PDFRubberStampAnnotation("Confidential", (mediaBox.width - 150)/2, 100, 150, 50, trueTypeFont);
		// sets the background for the rubber stamp annotation
		rubberStampAnnotation1.setBackground(createRandomColor());
		// sets the background for the rubber stamp annotation
		rubberStampAnnotation1.setForeground(createRandomColor());
		// sets the background for the rubber stamp annotation
		rubberStampAnnotation1.setBorderColor(createRandomColor());
		// adds the rubber stamp annotation to the page
		page.addAnnotation(rubberStampAnnotation1);

		PDFRubberStampAnnotation rubberStampAnnotation2 = new PDFRubberStampAnnotation("Departmental", (mediaBox.width - 125)/2, 170, 125, 50, trueTypeFont);
		rubberStampAnnotation2.setBackground(createRandomColor());
		rubberStampAnnotation2.setForeground(createRandomColor());
		rubberStampAnnotation2.setBorderColor(createRandomColor());
		page.addAnnotation(rubberStampAnnotation2);

		PDFRubberStampAnnotation rubberStampAnnotation3 = new PDFRubberStampAnnotation("Experimental", (mediaBox.width - 125)/2, 240, 125, 50, trueTypeFont);
		rubberStampAnnotation3.setBackground(createRandomColor());
		rubberStampAnnotation3.setForeground(createRandomColor());
		rubberStampAnnotation3.setBorderColor(createRandomColor());
		page.addAnnotation(rubberStampAnnotation3);

		PDFRubberStampAnnotation rubberStampAnnotation4 = new PDFRubberStampAnnotation("Not For Public Release", (mediaBox.width - 170)/2, 310, 170, 50, trueTypeFont);
		rubberStampAnnotation4.setBackground(createRandomColor());
		rubberStampAnnotation4.setForeground(createRandomColor());
		rubberStampAnnotation4.setBorderColor(createRandomColor());
		page.addAnnotation(rubberStampAnnotation4);

		PDFRubberStampAnnotation rubberStampAnnotation5 = new PDFRubberStampAnnotation("ForPublicRelease", (mediaBox.width - 170)/2, 380, 170, 50, trueTypeFont);
		rubberStampAnnotation5.setBackground(createRandomColor());
		rubberStampAnnotation5.setForeground(createRandomColor());
		rubberStampAnnotation5.setBorderColor(createRandomColor());
		page.addAnnotation(rubberStampAnnotation5);
		return page;
	}

	// creates the annotation page 2
	private Page createPDFAnnotationPage2() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Text and Link Annotation Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		// creates the PDFTextAnnotation with text, x, y, width and height
		PDFTextAnnotation pdfTextAnnotation = new PDFTextAnnotation("This is a PDFText Annotation Demo", 50, 70, 200, 100);
		// sets the title for the PDFTextAnnotation
		pdfTextAnnotation.setTitle("This is a PDFText Annotation's Title");
		// sets the open status to false for the PDFTextAnnotation
		pdfTextAnnotation.setOpen(false);
		// sets the color for the PDFTextAnnotation
		pdfTextAnnotation.setColor(createRandomColor());
		// adds the PDFTextAnnotation to the page
		page.addAnnotation(pdfTextAnnotation);

		String urlName = "www.elegantJBeans.com";
		int width = trueTypeFont.getStringWidth(urlName);
		// creates the text for the PDFLinkAnnotation,
		// on clicking which the site will be open in IE
		PDFText text = new PDFText(urlName, 50, 300, 50 + width, 300 + 23);
		// sets the font size
		text.setFontSize(20);
		// sets the fill color for the PDFText
		text.setFillColor(createRandomColor());
		// adds the text to the page on clicking which the site will be open in IE
		page.addText(text);
		// creates the pdf link annotation with page, x, y, widht height and URL
		PDFLinkAnnotation pdfLinkAnnotation = new PDFLinkAnnotation(50, 300, width, 23, new URL("http://www.elegantJBeans.com"));
		// adds the annotaion to the page
		page.addAnnotation(pdfLinkAnnotation);
		return page;
	}

	// creates the PDFImage page
	private Page createPDFImagePage() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Image Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

/*		// creates the PDFImage with image URL
		PDFImage image1 = new PDFImage(getClass().getResource("./resources/image1.jpg"));
		// sets the x coordinate for the image
		image1.setImageX((mediaBox.width - 300)/2);
		// sets the y coordinate for the image
		image1.setImageY(100);
		// sets the width for the image
		image1.setImageWidth(300);
		// sets the height for the image
		image1.setImageHeight(200);
		// adds the image to the page
		page.addImage(image1);
*/

		// creates the PDFImage with the URL
          Image oImage = Toolkit.getDefaultToolkit().getImage(getClass().getResource("./resources/image3.jpg"));
		PDFImage image2 = new PDFImage(oImage);
		// sets the x coordinate for the image
		image2.setImageX((mediaBox.width - 300)/2);
		// sets the y coordinate for the image
		image2.setImageY(350);
		// sets the image width for the image
		image2.setImageWidth(300);
		// sets the image height for the image
		image2.setImageHeight(200);
		// adds the image to the page
		page.addImage(image2);
		return page;
	}

	// creates the PDFTable page1
	private Page createPDFTablePage1() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Table Demo", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		// creates the PDFTable object with x, y, width and height
		PDFTable pdfTable = new PDFTable(50, mediaBox.y + 50 + 40, mediaBox.width - 100, mediaBox.height - 150);
		// get data from create data method
		Vector data = createData();
		// sets the row count for the PDFTable
		pdfTable.setRowCount(data.size());
		// sets the column count for the PDFTable
		pdfTable.setColumnCount(((Vector)data.elementAt(0)).size());
		// sets the data for the PDFTable
		pdfTable.setData(data);
		// sets the row height at the 0th position
		pdfTable.setRowHeightAt(0, 20);
		// sets the row background at the 0th row
		pdfTable.setRowBackgroundAt(0, Color.lightGray);
		// sets the column alignment at the 1 to the CENTER
		pdfTable.setColumnAlignmentAt(1, PDFText.CENTER);
		// sets the column alignment at the 2 to the CENTER
		pdfTable.setColumnAlignmentAt(2, PDFText.CENTER);
		// sets the column alignment at the 4 to the RIGHT
		pdfTable.setColumnAlignmentAt(4, PDFText.RIGHT);
		// adds the PDFTable to the page
		page.addTable(pdfTable);
		return page;
	}

	// creates the PDFTable page2
	private Page createPDFTablePage2() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Table Demo using Background and Foreground", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFTable pdfTable = new PDFTable(50, mediaBox.y + 50 + 40, mediaBox.width - 100, mediaBox.height - 150);
		Vector data = createData();
		pdfTable.setRowCount(data.size());
		pdfTable.setColumnCount(((Vector)data.elementAt(0)).size());
		pdfTable.setData(data);
		pdfTable.setRowHeightAt(0, 20);
		pdfTable.setRowBackgroundAt(0, Color.lightGray);
		pdfTable.setColumnAlignmentAt(4, PDFText.RIGHT);
		for(int i = 1; i < pdfTable.getRowCount(); i++)
		{
			for(int j = 0; j < pdfTable.getColumnCount(); j++)
			{
				// seta the cell background at the ith and jth position
				pdfTable.setCellBackgroundAt(i, j, createRandomColor());
				// seta the cell foreground at the ith and jth position
				pdfTable.setCellForegroundAt(i, j, createRandomColor());
			}
		}
		pdfTable.setColumnAlignmentAt(1, PDFText.CENTER);
		pdfTable.setColumnAlignmentAt(2, PDFText.CENTER);
		pdfTable.setColumnAlignmentAt(4, PDFText.RIGHT);
		page.addTable(pdfTable);
		return page;
	}

	// creates the PDFTable page3
	private Page createPDFTablePage3() throws IOException
	{
		Page page = new Page(pdf.getPages(), mediaBox);
		PDFText	label = new PDFText("ElegantJ PDF Table Demo using Pattern", mediaBox.x + 50, mediaBox.y + 50, mediaBox.width - 50, mediaBox.y + 50 + 40);
		label.setPDFFont(labelFont);
		label.setFontSize(18);
		label.setFillColor(HEADER_TEXT_FILL_COLOR);
		label.setAlignment(PDFText.CENTER);
		label.setUnderLine(true);
		page.addText(label);

		PDFTable pdfTable = new PDFTable(50, mediaBox.y + 50 + 40, mediaBox.width - 100, mediaBox.height - 150);
		Vector data = createData();
		pdfTable.setRowCount(data.size());
		pdfTable.setColumnCount(((Vector)data.elementAt(0)).size());
		pdfTable.setData(data);

		// creates the pattern
		PDFPattern pattern = new PDFPattern();
		// sets the image to the patten
		pattern.setImage(pdfImage);

		pdfTable.setRowHeightAt(0, 20);
		pdfTable.setRowBackgroundAt(0, Color.lightGray);
		pdfTable.setColumnAlignmentAt(1, PDFText.CENTER);
		pdfTable.setColumnAlignmentAt(2, PDFText.CENTER);
		pdfTable.setColumnAlignmentAt(4, PDFText.RIGHT);
		// sets the patter for the whole table
		pdfTable.setDefaultBackgroundPattern(pattern);
		page.addTable(pdfTable);
		return page;
	}

	// creates the outline tree for the PDF
	private void createOutlinesTree()
	{
		// Get the instance of root of the outlines
		Outlines baseOutline = pdf.getOutlines();

		// Create the new outlines with destinations page
		Outlines pdfTextDemo = new Outlines(pdf, "PDF Text Demo", pdfTextAttributesPage1);
		Outlines pdfTextDemo1 = new Outlines(pdf, "Text Attributes 1", pdfTextAttributesPage1);
		Outlines pdfTextDemo2 = new Outlines(pdf, "Text Attributes 2", pdfTextAttributesPage2);
		// adds the outlines to the outlines
		pdfTextDemo.add(pdfTextDemo1);
		// adds the outlines to the outlines
		pdfTextDemo.add(pdfTextDemo2);
		Outlines pdfFontDemo = new Outlines(pdf, "PDF Font Demo", pdfFontPage);
		Outlines pdfLineDemo = new Outlines(pdf, "PDF Line Demo", pdfLinePage);
		Outlines pdfRectangleDemo = new Outlines(pdf, "PDF Rectangle Demo", pdfRectanglePage);
		Outlines pdfCircleDemo = new Outlines(pdf, "PDF Circle Demo", pdfCirclePage);
		Outlines pdfOvalDemo = new Outlines(pdf, "PDF Oval Demo", pdfOvalPage);
		Outlines pdfArcDemo = new Outlines(pdf, "PDF Arc Demo", pdfArcPage);
		Outlines pdfPolygonDemo = new Outlines(pdf, "PDFPolygonDemo", pdfPolygonPage);
		Outlines pdfPatternDemo = new Outlines(pdf, "PDF Pattern Demo", pdfPatternPage1);
		Outlines pdfPatternDemo1 = new Outlines(pdf, "Pattern with Text", pdfPatternPage1);
		Outlines pdfPatternDemo2 = new Outlines(pdf, "Pattern with Graphics", pdfPatternPage2);
		// adds the outlines to the outlines
		pdfPatternDemo.add(pdfPatternDemo1);
		// adds the outlines to the outlines
		pdfPatternDemo.add(pdfPatternDemo2);
		Outlines pdfAnnotationDemo = new Outlines(pdf, "PDF Annotations Demo", pdfAnnotationPage1);
		Outlines pdfAnnotationDemo1 = new Outlines(pdf, "Rubber Stamp Annotation", pdfAnnotationPage1);
		Outlines pdfAnnotationDemo2 = new Outlines(pdf, "Other Annotation", pdfAnnotationPage2);
		// adds the outlines to the outlines
		pdfAnnotationDemo.add(pdfAnnotationDemo1);
		// adds the outlines to the outlines
		pdfAnnotationDemo.add(pdfAnnotationDemo2);
		Outlines pdfImageDemo = new Outlines(pdf, "PDF Image Demo", pdfImagePage);
		Outlines pdfTableDemo = new Outlines(pdf, "PDF Table Demo", pdfTablePage1);
		Outlines pdfTableDemo1 = new Outlines(pdf, "PDF Table 1", pdfTablePage1);
		Outlines pdfTableDemo2 = new Outlines(pdf, "PDF Table 2", pdfTablePage2);
		Outlines pdfTableDemo3 = new Outlines(pdf, "PDF Table 3", pdfTablePage3);
		pdfTableDemo.add(pdfTableDemo1);
		pdfTableDemo.add(pdfTableDemo2);
		pdfTableDemo.add(pdfTableDemo3);

		// finally add the outlines to the the base outline
		baseOutline.add(pdfTextDemo);
		baseOutline.add(pdfFontDemo);
		baseOutline.add(pdfLineDemo);
		baseOutline.add(pdfRectangleDemo);
		baseOutline.add(pdfCircleDemo);
		baseOutline.add(pdfOvalDemo);
		baseOutline.add(pdfArcDemo);
		baseOutline.add(pdfPolygonDemo);
		baseOutline.add(pdfPatternDemo);
		baseOutline.add(pdfAnnotationDemo);
		baseOutline.add(pdfImageDemo);
		baseOutline.add(pdfTableDemo);
	}

	// creates and returns new random color
	private Color createRandomColor()
	{
		return new Color((int)(Math.random()*300%255), (int)(Math.random()*300%255), (int)(Math.random()*300%255));
	}

	/**
	 * Method which creates the 2-dimensional data vector
	 * specially for the PDFTable only
	 */
	private Vector createData()
	{
		Vector data = new Vector();
		Vector rowData = new Vector();
		rowData.addElement("Employee ID");
		rowData.addElement("First Name");
		rowData.addElement("Last Name");
		rowData.addElement("Address");
		rowData.addElement("Salary");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Fran");
		rowData.addElement("Whitney");
		rowData.addElement("49 East Washington Street\nNeedham\nMA\nZip 02192");
		rowData.addElement("$45700.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Matthew");
		rowData.addElement("Cobb");
		rowData.addElement("77 Pleasant Street\nWaltham\nMA\nZip 02154");
		rowData.addElement("$62000.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Philip");
		rowData.addElement("Chin");
		rowData.addElement("59 Pond Street\nAtlanta\nGA\nZip 30339");
		rowData.addElement("$38500.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Julie");
		rowData.addElement("Jordan");
		rowData.addElement("144 Great Plain Avenue\nWinchester\nMA\nZip 01890");
		rowData.addElement("$51432.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Robert");
		rowData.addElement("Breault");
		rowData.addElement("58 Cherry Street\nMilton\nMA\nZip 02186");
		rowData.addElement("$57490.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Melissa");
		rowData.addElement("Espinoza");
		rowData.addElement("112 Apple Tree Way\nStow\nMA\nZip 01775");
		rowData.addElement("$36490.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Jeannett");
		rowData.addElement("Bertrand");
		rowData.addElement("209 Concord Street\nActon\nMA\nZip 01720");
		rowData.addElement("$32780.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Marc");
		rowData.addElement("Dill");
		rowData.addElement("89 Hancock Street\nMilton\nMA\nZip 02186");
		rowData.addElement("$54800.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Jane");
		rowData.addElement("Francis");
		rowData.addElement("12 Hawthorne Drive\nConcord\nMA\nZip 01742");
		rowData.addElement("$53870.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Natasha");
		rowData.addElement("Shishov");
		rowData.addElement("15 Milk Street\nWaltham\nMA\nZip 02154");
		rowData.addElement("$72995.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Kurt");
		rowData.addElement("Driscoll");
		rowData.addElement("154 School Street\nWaltham\nMA\nZip 02154");
		rowData.addElement("$48023.690");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Rodrigo");
		rowData.addElement("Guevara");
		rowData.addElement("East Main Street\nFramingham\nMA\nZip 01701");
		rowData.addElement("$42998.000");
		data.addElement(rowData);

		rowData = new Vector();
		rowData.addElement("emp-00000" + data.size() + 1);
		rowData.addElement("Ram");
		rowData.addElement("Gowda");
		rowData.addElement("79 Page Street\nNatick\nMA\nZip 01760");
		rowData.addElement("$59840.000");
		data.addElement(rowData);
		return data;
	}

	/**
	 * Main method for this demo
	 */
	public static void main(String args[])
	{
		try
		{
			// constructs the obejct of the EJPDFDemo
			EJPDFDemo ejPDFDemo = new EJPDFDemo();
			System.exit(0);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}